Compress::Gzip::Reader - Crystal 1.16.3

# class Compress::Gzip::Reader

- Compress::Gzip::Reader
- IO
- Reference
- Object

##
Overview

A read-only `IO` object to decompress data in the gzip format.

Instances of this class wrap another IO object. When you read from this instance instance, it reads data from the underlying IO, decompresses it, and returns it to the caller.

NOTE A gzip stream can contain zero or more members. If it contains no members, `#header` will be `nil`. If it contains one or more members, only the first header will be recorded here. This is because gzipping multiple members is not common as one usually combines gzip with tar. If, however, multiple members are present then reading from this reader will return the concatenation of all the members.

###
Example: decompress a gzip file

    require "compress/gzip"

    File.write("file.gzip", Bytes[31, 139, 8, 0, 0, 0, 0, 0, 0, 3, 75, 76, 74, 6, 0, 194, 65, 36, 53, 3, 0, 0, 0])

    string = File.open("file.gzip") do |file|
      Compress::Gzip::Reader.open(file) do |gzip|
        gzip.gets_to_end
      end
    end
    string # => "abc"

##
Included Modules

- IO::Buffered

##
Defined in:

compress/gzip/reader.cr

##
Constructors

- .new(io : IO, sync_close : Bool = false)

  Creates a new reader from the given io.

- .new(filename : String)

  Creates a new reader from the given filename.

##
Class Method Summary

- .open(io : IO, sync_close = false, &)

  Creates a new reader from the given io, yields it to the given block, and closes it at the end.

- .open(filename : String, &)

  Creates a new reader from the given filename, yields it to the given block, and closes it at the end.

##
Instance Method Summary

- #closed? : Bool

  Returns `true` if this reader is closed.

- #header : Header | Nil

  Returns the first header in the gzip stream, if any.

- #sync_close=(sync_close : Bool)

  Whether to close the enclosed `IO` when closing this reader.

- #sync_close? : Bool

  Whether to close the enclosed `IO` when closing this reader.

- #unbuffered_close : Nil

  Closes this reader.

- #unbuffered_flush : NoReturn

  Flushes the wrapped `IO`.

- #unbuffered_read(slice : Bytes) : Int32

  See `IO#read`.

- #unbuffered_rewind : Nil

  Rewinds the wrapped `IO`.

- #unbuffered_write(slice : Bytes) : NoReturn

  Always raises `IO::Error` because this is a read-only `IO`.

### Instance methods inherited from module `IO::Buffered`

buffer_size : Int32 buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush flush, flush_on_newline=(flush_on_newline) flush_on_newline=, flush_on_newline? : Bool flush_on_newline?, peek : Bytes peek, pos : Int64 pos, read(slice : Bytes) : Int32 read, read_buffering=(read_buffering) read_buffering=, read_buffering? : Bool read_buffering?, rewind rewind, sync=(sync) sync=, sync? : Bool sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, chomp = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil
gets(chomp = true) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string, args : Array | Tuple) : Nil
printf(format_string, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : Int64
copy(src, dst) : Int64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO, sync_close : Bool = false) #

Creates a new reader from the given io.

def self.new(filename : String) #

Creates a new reader from the given filename.

##
Class Method Detail

def self.open(io : IO, sync_close = false, &) #

Creates a new reader from the given io, yields it to the given block, and closes it at the end.

def self.open(filename : String, &) #

Creates a new reader from the given filename, yields it to the given block, and closes it at the end.

##
Instance Method Detail

def closed? : Bool #

Returns `true` if this reader is closed.

def header : Header | Nil #

Returns the first header in the gzip stream, if any.

def sync_close=(sync_close : Bool) #

Whether to close the enclosed `IO` when closing this reader.

def sync_close? : Bool #

Whether to close the enclosed `IO` when closing this reader.

def unbuffered_close : Nil #

Closes this reader.

def unbuffered_flush : NoReturn #
Description copied from module IO::Buffered

Flushes the wrapped `IO`.

TODO Add return type restriction `Nil`

def unbuffered_read(slice : Bytes) : Int32 #

See `IO#read`.

def unbuffered_rewind : Nil #
Description copied from module IO::Buffered

Rewinds the wrapped `IO`.

TODO Add return type restriction `Nil`

def unbuffered_write(slice : Bytes) : NoReturn #

Always raises `IO::Error` because this is a read-only `IO`.